#include <gsl/gsl_rng.h>

gsl_rng *rng; // instance of a random number generator

// initialize the random number generator
void rng_init2() {
  // reads the environment variables GSL_RNG_TYPE and GSL_RNG_SEED and set the variables gsl_rng_default and gsl_rng_default_seed
  gsl_rng_env_setup();

  // random number generator initialization
  rng = gsl_rng_alloc(gsl_rng_default); 

  // seed the random number generator
  gsl_rng_set(rng, gsl_rng_default_seed);

  printf("random number generator type: %s\n", gsl_rng_name(rng));
  printf("random number seed: %lu\n", gsl_rng_default_seed);
}

// initialize an array with random values
void rng_array2(double* array, int size) {
  // printf("size = %d\n", size); // -> useful to check the Fortran/C wrapper

  for(int i=0; i<size; i++) {
    // double precision floating point number uniformly distributed in the range [0.0, 1.0[.
    array[i] = gsl_rng_uniform(rng);
  }
}

// free the random number generator
void rng_free2() {
  gsl_rng_free(rng);
}
